﻿Public Class Row_Dragging
    Dim dt As System.Data.DataTable

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        dt = New DataTable()
        dt.Columns.Add("ID", GetType(Integer))
        dt.Columns.Add("First Name", GetType(String))
        dt.Columns.Add("Last Name", GetType(String))
        dt.Columns.Add("Title", GetType(String))

        'Sample Data
        dt.Rows.Add(1, "Peter", "Huggs", "Developer")
        dt.Rows.Add(2, "Jill", "Tuck", "Admin")
        dt.Rows.Add(3, "Martin", "Jackson", "Support")
        dt.Rows.Add(4, "Mark", "Jones", "Tester")
        dt.Rows.Add(5, "Patrik", "Jenes", "Admin")
        dt.Rows.Add(6, "Philip", "Nukes", "Support")
        dt.Rows.Add(7, "Marco", "Bradman", "Tester")
        dt.Rows.Add(8, "Amanda", "Young", "Developer")
        dt.Rows.Add(9, "John", "Krammer", "Engineer")
        dt.Rows.Add(10, "Tedd", "Fartoos", "Developer")

        C1FlexGrid1.Styles.Alternate.BackColor = Color.LightPink
        C1FlexGrid1.AllowDragging = C1.Win.C1FlexGrid.AllowDraggingEnum.Rows

        ' bind to grid
        C1FlexGrid1.DataSource = dt
        'Set Text Alignment
        C1FlexGrid1.Cols(1).TextAlign = C1.Win.C1FlexGrid.TextAlignEnum.CenterCenter
        C1FlexGrid1.Cols(2).TextAlign = C1.Win.C1FlexGrid.TextAlignEnum.CenterCenter
        C1FlexGrid1.Cols(3).TextAlign = C1.Win.C1FlexGrid.TextAlignEnum.CenterCenter
        C1FlexGrid1.Cols(4).TextAlign = C1.Win.C1FlexGrid.TextAlignEnum.CenterCenter
        C1FlexGrid1.Cols(1).TextAlignFixed = C1.Win.C1FlexGrid.TextAlignEnum.CenterCenter
        C1FlexGrid1.Cols(2).TextAlignFixed = C1.Win.C1FlexGrid.TextAlignEnum.CenterCenter
        C1FlexGrid1.Cols(3).TextAlignFixed = C1.Win.C1FlexGrid.TextAlignEnum.CenterCenter
        C1FlexGrid1.Cols(4).TextAlignFixed = C1.Win.C1FlexGrid.TextAlignEnum.CenterCenter


    End Sub

    Private Sub C1FlexGrid1_BeforeDragRow(sender As Object, e As C1.Win.C1FlexGrid.DragRowColEventArgs) Handles C1FlexGrid1.BeforeDragRow
        Dim drDragged As System.Data.DataRow = dt.Rows(e.Row - 1)
        Dim drNewPosition As System.Data.DataRow = dt.Rows(e.Position - 1)

        Dim arr1 As Object() = drDragged.ItemArray
        Dim arr2 As Object() = drNewPosition.ItemArray

        dt.Rows.Remove(drDragged)
        dt.Rows.Remove(drNewPosition)

        Dim dr1 As DataRow = dt.NewRow()
        dr1.ItemArray = arr1                            'Temporary Row to store data of row being dragged
        Dim dr2 As DataRow = dt.NewRow()
        dr2.ItemArray = arr2                            'Temporary Row to store data of row at which it is dropped

        dt.Rows.InsertAt(dr1, e.Position - 1)           'Inserting Rows at Swapped Postions
        dt.Rows.InsertAt(dr2, e.Row - 1)

        C1FlexGrid1.DataSource = dt
        e.Cancel = True                                 ' To Suppress default Dragging Behaviour
    End Sub
End Class
